//------------------------------------------------------------------------
// http://ironfelix.ru  Conqeror ()
//        
//
//  Arsen: 12.03.2005,
//         -  5    ,  LED
//         -  LED      
//         -     "" 
//         -     
//  Arsen: 20.04.2006,
//         -       GCC
//              WinAVR v 3.4.5,  20060125
//------------------------------------------------------------------------

#include <inttypes.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <compat/deprecated.h>

//      
#define OUT PORTB
#define MOTOR_FR  PB7  // -
#define MOTOR_BR  PB6  // -
#define MOTOR_BL   PB5  // -
#define MOTOR_FL   PB4  // -

#define IN PIND
#define LED PD6 // 


//      
// R, L -     , 

enum {STOP, F, FR, FL, B, BR, BL, R, L};

//------------------------------------------------------------------------------
//  t  10ms
//------------------------------------------------------------------------------
#define K_DELAY_10ms	F_CPU/600   //  F_CPU=4000000
void Delay_10ms(unsigned char t) {
  if (t==0) return;
  unsigned int i;
  while (t--) for(i=0;i<K_DELAY_10ms; i++);
}

//------------------------------------------------------------------------------
// ,  0.1   
//------------------------------------------------------------------------------

void Delay(unsigned char t) {
  unsigned int i;
  for (i=0;i<t;i++){
       cbi(PORTD, LED); //    PD4
       Delay_10ms(100);   //     2.5 
       sbi(PORTD, LED); //    PD4
       Delay_10ms(100);   //     2.5 
        }
}



//------------------------------------------------------------------------------
//      
//   ,    
//------------------------------------------------------------------------------
void go(unsigned char direction){

  switch (direction) {
  case STOP:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case F:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case FR:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case FL:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case B:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case BR:
    cbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case BL:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;

  case R:
    cbi(OUT, MOTOR_FR);
    sbi(OUT, MOTOR_BR);
    cbi(OUT, MOTOR_BL);
    sbi(OUT, MOTOR_FL);
    break;

  case L:
    sbi(OUT, MOTOR_FR);
    cbi(OUT, MOTOR_BR);
    sbi(OUT, MOTOR_BL);
    cbi(OUT, MOTOR_FL);
    break;
  }
}


//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
int main(void)
{
  DDRB  = 0xff;  //     B  
  PORTB = 0x00;  //      

  DDRD  = 0x40;  //     D  ,  PD6
  PORTD = 0xbf;  //    ,  PD6


//     5 
//       :)

  //      
  unsigned char i;

  for (i=0;i<5;i++){   //   
    cbi(PORTD, LED); //  LED
    Delay_10ms(250);  // 
    sbi(PORTD, LED); //  LED
    Delay_10ms(250);  // 
    }

  for (i=0;i<5;i++){   // -  
    go(F);   // 
    Delay (1);
    go(STOP); // 
    Delay (1);

    go(B);   // 
    Delay (1);
    go(STOP); // 
    Delay (1);
    }

  for (i=0;i<5;i++){   //  -  
    go(FR);   // -
    Delay (i+1);
    go(STOP); // 
    Delay (1);

    go(BR);   // -
    Delay (i+1);
    go(STOP); // 
    Delay (1);
    }

  for (i=0;i<5;i++){   //   -  
    go(FL);   // -
    Delay (i+1);
    go(STOP); // 
    Delay (1);

    go(BL);   // -
    Delay (i+1);
    go(STOP); // 
    Delay (1);
    }

  for (i=0;i<10;i++){   //    -  
    go(R);   //  
    Delay (i+1);
    go(STOP); // 
    Delay (1);

    go(L);   //  
    Delay (i+1);
    go(STOP); // 
    Delay (1);
   }

return (0);
}


